- block:
  - include_role:
      name: commons
      tasks_from: helpers/volume.yaml
    vars:
      vol_name: "{{ sonarqube_pg_name }}-{{ target }}-snap"
      vol_size: "{{ sonarqube_db_data_capacity }}"
  - name: Marks operation in progress
    set_fact:
      snap_failed: True
    when:
    - has_pvc is defined
    - has_pvc.resources is defined
    - (has_pvc.resources | length) > 0
  - name: Scales SonarQube down to 0
    async: 30
    k8s:
      definition:
        apiVersion: "{{ deployment_apivers }}"
        kind: "{{ deployment_kind }}"
        metadata:
          name: "{{ sonarqube_name }}"
          namespace: "{{ namespace }}"
        spec:
          replicas: 0
    poll: 5
    when:
    - not (snap_failed | default(False))
  - include_role:
      name: commons
      tasks_from: snapshots/postgres.yaml
    vars:
      db_data_capacity: "{{ sonarqube_db_data_capacity }}"
      db_host: "{{ sonarqube_pg_name }}"
      db_secret_name: "{{ sonarqube_pg_name }}"
      job_assume_pod_netpol: "{{ sonarqube_name }}"
      provision_volume: False
      snap_mark: "{{ target }}"
      snap_wait_for: 30
      snap_wait_retries: 120
    when:
    - not (snap_failed | default(False))
  - name: Lookups Postgres Snapshot Job
    async: 30
    changed_when: False
    k8s_info:
      api_version: batch/v1
      kind: Job
      namespace: "{{ namespace }}"
      name: "{{ sonarqube_pg_name }}-{{ target }}-snap"
    no_log: True
    poll: 5
    register: pg_snap
    when:
    - not (snap_failed | default(False))
  - block:
    - name: Reverts Upgrade when snapshot failed
      async: 30
      k8s:
        definition:
          apiVersion: "{{ deployment_apivers }}"
          kind: "{{ deployment_kind }}"
          metadata:
            name: "{{ sonarqube_name }}"
            namespace: "{{ namespace }}"
          spec:
            replicas: 1
      poll: 5
    - name: Fails when snapshot failed
      fail:
        msg: "Failed upgrading SonarQube to {{ target }}"
    when:
    - >
        snap_failed | default(False)
        or (pg_snap is defined
            and pg_snap.resources is defined
            and (pg_snap.resources | length == 0
                 or (pg_snap.resources[0].status is defined
                     and pg_snap.resources[0].status is defined
                     and (pg_snap.resources[0].status.completionTime is not defined
                          or (not ((pg_snap.resources[0].status.succeeded | default(0)) in [ 1, '1' ]))))))
  when:
  - do_backups
- block:
  - include_role:
      name: commons
      tasks_from: helpers/deployment.yaml
    vars:
      cpu_limit: "{{ sonarqube_cpu_limit }}"
      cpu_request: "{{ sonarqube_cpu_request }}"
      dc_data: "{{ lookup('template', 'sonarqube.j2') }}"
      dc_name: "{{ sonarqube_name }}"
      dc_replicas: 1
      dc_tag: "{{ target }}"
      memory_limit: "{{ sonarqube_memory_limit }}"
      memory_request: "{{ sonarqube_memory_request }}"
  - include_role:
      name: commons
      tasks_from: helpers/wait-for.yaml
    vars:
      check_with: "{{ lookup('k8s', api_version=deployment_apivers,
                             kind=deployment_kind, namespace=namespace,
                             resource_name=sonarqube_name) | default('') }}"
      obj_name: "{{ sonarqube_name }}"
      retries_for: 60
      wait_for: 10
    when:
    - dc_started is defined
    - dc_started is changed
  - name: Checks SonarQube Upgrade Status
    async: 30
    changed_when: False
    k8s_info:
      api_version: "{{ deployment_apivers }}"
      kind: "{{ deployment_kind }}"
      name: "{{ sonarqube_name }}"
      namespace: "{{ namespace }}"
    no_log: True
    poll: 5
    register: has_sq
  - name: Fails when upgrade is still running
    fail:
      msg: "Failed upgrading SonarQube to {{ target }}"
    when:
    - has_sq is defined
    - has_sq.resources is defined
    - has_sq.resources | length > 0
    - has_sq.resources[0].status is defined
    - has_sq.resources[0].status.readyReplicas is defined
    - has_sq.resources[0].status.readyReplicas == 0
  when:
  - not (snap_failed | default(False))
